//
//  DC_SearchDefinition.h
//  DataCrux
//
//  Created by Scott Stevenson on Sun Dec 07 2003.
//  Copyright (c) 2003 Tree House Ideas. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "DataCrux-Types.h"

@interface DC_SearchDefinition : NSObject {

    NSString * uniqueID;
    NSString * criteriaGroupID;
    
    // loaded statically from property list
    
    NSDictionary    * criteriaProperties;
    
    // unit name (aka "DataCrux type") for this search
    
    NSString        * unitName;
    
    // all search critera supplied by client application.
    // Some may potentially be nested DC_SearchDefinition objects.
    
    NSMutableArray  * allSearchCriteria;
}



- (id) initWithType: (NSString *)theType;


// single value

- (BOOL) addCriteria: (DCSearchCriteria)theProperty
           forMember: (NSString *)theMember
           withValue: (id)theValue
             options: (DCSearchOptions)searchFlags;

- (BOOL) addCriteria: (DCSearchCriteria)theProperty
           forMember: (NSString *)theMember
           withValue: (id)theValue;


// multiple value

- (BOOL) addCriteria: (DCSearchCriteria)theProperty
           forMember: (NSString *)theMember
          withValues: (id)theValue
             options: (DCSearchOptions)options;

- (BOOL) addCriteria: (DCSearchCriteria)theProperty
           forMember: (NSString *)theMember
          withValues: (NSArray *)theValues;


// return array of all search criteria supplied by client app

- (NSString *)uniqueID;
- (void)setUniqueID:(NSString *)anUniqueID;
- (NSString *)criteriaGroupID;
- (void)setCriteriaGroupID:(NSString *)aCriteriaGroupID;


- (NSMutableArray *)    allSearchCriteria;

- (NSString *)          unitName;
- (NSArray *)           nestedUnitNames;
- (NSArray *)           allUnitNames;



// private

- (void) configureStrings;

@end



DCSearchCriteria intToDCSearchCriteria (NSInteger theInt);

