//
//  DataCrux-Types.h
//  DataCrux
//
//  Created by Scott Stevenson on Sat Dec 04 2003.
//  Copyright (c) 2003 Tree House Ideas. All rights reserved.
//

#import <Foundation/Foundation.h>


// query types

typedef enum _DCSQLQueryType {
    
    DCSQLSelectQueryType        = 1,
    DCSQLInsertQueryType        = 2,
    DCSQLUpdateQueryType        = 3,
    DCSQLDeleteQueryType        = 4
} 
DCSQLQueryType;


// content types

typedef enum _DCContentsHint {
    
    DCValueContentsHint             = 1,    // __value__
    DCArrayContentsHint             = 2,    // __array__
    DCDictionaryContentsHint        = 3,    // __dictionary__
    DCPrimaryKeyContentsHint        = 4,    // __primary_key__
    DCIntegerContentsHint           = 5,    // __integer__ (NSNumber stored as intValue)
    DCFloatContentsHint             = 6,    // __float__ (NSNumber stored as floatValue)
    DCDateContentsHint              = 7,    // __date__ (NSDate stored as epoch)
    DCDynamicContentsHint           = 8,     // __dynamic__ (same as primary key but dynamically typed)
    DCSearchDefinitionContentsHint  = 9     // __search_definition__
    
} DCContentsHint;


// search types

typedef enum _DCSearchCriteria {
    
    DCEqualToSearch             = 1,
    DCNotEqualToSearch          = 2,    // deprecated    
    DCContainsStringSearch      = 3,
    DCBeginsWithStringSearch    = 11,
    DCEndsWithStringSearch      = 12,    
    DCNumberGreaterThanSearch   = 4,
    DCNumberLessThanSearch      = 5,
    DCNumberRangeSearch         = 6,        
    DCDateGreaterThanSearch     = 7,
    DCDateLessThanSearch        = 8,
    DCDateRangeSearch           = 9,    
    DCNestedSearch              = 10
    
} DCSearchCriteria;

enum {
    DCNegateSearchOption        = 0x01,
    DCAlternateSearchOption     = 0x02
};
typedef NSUInteger DCSearchOptions;



// private collection types

typedef enum _DCObjectInfoCachedMapResult {
    
    DCObjectInfoNotFoundInMapCache = -1
    
} DCObjectInfoCachedMapResult;

typedef enum _DCCollectionLoadResult {
    
    DCCollectionNotFoundInDatabase = -1,
    DCCollectionDidLoad            =  1
    
} DCCollectionLoadResult;


typedef enum _DCCollectionStorageResult {
    
    DCCollectionStorageError       = -1,
    DCEmptyCollectionWarning       =  0
    
} DCCollectionStorageResult;

