//
//  MMSLocationTimeMarker.h
//  MMSBase
//
//  Created by John Fox on 6/16/08.
//  Copyright 2008 GroupSmarts, LLC. All rights reserved.
//

#import "MMSPersistentObject.h"

#import "MMSPerson.h"
#import "MMSLocation.h"
#import "MMSPhoto.h"

#import <Foundation/Foundation.h>


@interface MMSLocationTimeMarker : MMSPersistentObject 
{
	NSString *address;
    NSString *name;
    NSString *notes;
    NSNumber *latitude;
	NSNumber *longitude;
	NSNumber *locationRadius;
	NSNumber *timeRadius;
	NSDate *radiusDate;
	NSDate *beginDate;
	NSDate *endDate;
	NSNumber *isCurrent;
	
    MMSPerson *person;
	MMSLocation *location;
}

//
// Conveniences
//

- (NSArray *)photoIDsWithinTimeRange;
- (NSArray *)photosWithinTimeRange;
- (BOOL)hasLatLongValues;
- (NSString *)htmlDescription;


//
// Accessors
//

- (NSString *)address;
- (void)setAddress:(NSString *)anAddress;

- (NSDate *)beginDate;
- (void)setBeginDate:(NSDate *)aBeginDate;

- (NSDate *)endDate;
- (void)setEndDate:(NSDate *)anEndDate;

- (NSNumber *)isCurrent;
- (void)setIsCurrent:(NSNumber *)anIsCurrent;

- (NSString *)name;
- (void)setName:(NSString *)aName;

- (NSString *)notes;
- (void)setNotes:(NSString *)aNotes;

- (NSNumber *)latitude;
- (void)setLatitude:(NSNumber *)aLatitude;

- (NSNumber *)longitude;
- (void)setLongitude:(NSNumber *)aLongitude;

- (NSNumber *)locationRadius;
- (void)setLocationRadius:(NSNumber *)aLocationRadius;

- (NSNumber *)timeRadius;
- (void)setTimeRadius:(NSNumber *)aTimeRadius;

- (NSDate *)radiusDate;
- (void)setRadiusDate:(NSDate *)aRadiusDate;

- (MMSPerson *)person;
- (void)setPerson:(MMSPerson *)aPerson;

- (MMSLocation *)location;
- (void)setLocation:(MMSLocation *)aLocation;

@end
