//
//  MMSMediaFeedParser.h
//  MMSBase
//
//  Created by John Fox on 4/19/08.
//  Copyright 2008 GroupSmarts, LLC. All rights reserved.
//

#import <Foundation/Foundation.h>


@interface MMSMediaFeedParser : NSObject 
{	
	NSURL *feedURL;
	NSXMLDocument *rssDoc;
	NSDictionary *headerInfoDict;
	NSArray *itemInfoDictArray;
	
	BOOL isAtomFeed;
}

+ (id)newWithURL:(NSURL *)anURL;

- (NSError *)parseFeed;

- (NSArray *)getParsedItems;
- (NSDictionary *)headerInfoDictFromChannelElement:(NSXMLElement *)aChannelElement;

//
// Conveniences
//
- (NSDate *)lastUpdateDate;
- (NSDate *)originalPubDate;

//
// Accessors
//

- (NSURL *)feedURL;
- (void)setFeedURL:(NSURL *)aFeedURL;

- (NSDictionary *)headerInfoDict;
- (void)setHeaderInfoDict:(NSDictionary *)aHeaderInfoDict;

- (BOOL)isAtomFeed;

- (NSArray *)itemInfoDictArray;
- (void)setItemInfoDictArray:(NSArray *)anItemInfoDictArray;

- (NSXMLDocument *)rssDoc;
- (void)setRssDoc:(NSXMLDocument *)anRssDoc;

@end
