//
//  MMSPersonRelationshipType.h
//  MemoryMiner
//
//  Created by John Fox on 1/25/05.
//  Copyright 2005 MemoryMiner Software. All rights reserved.
//

#import "MMSPersistentObject.h"

#import "MMSPerson.h"

#import <Foundation/Foundation.h>

@interface MMSPersonRelationshipType : MMSPersistentObject 
{
    NSString *classification;
    NSString *localizationKey;
    NSString *gender;
}

//
// Fetching
// 
+ (NSArray *)sortedRelationshipTypes;

+ (MMSPersonRelationshipType *)relationshipTypeForSourcePerson:(MMSPerson *)aSourcePerson
                                            destinationPerson:(MMSPerson *)aDestPerson;

//
// Conveniences
// 
- (NSString *)name;

//
// Accessors
//
- (NSString *)classification;
- (void)setClassification:(NSString *)aClassification;

- (NSString *)localizationKey;
- (void)setLocalizationKey:(NSString *)aKey;

- (NSString *)gender;
- (void)setGender:(NSString *)value;


@end
