//
//  MMSWebServiceInvocation.h
//  MMSBase
//
//  Created by John Fox on 6/23/06.
//  Copyright 2006 GroupSmarts, LLC. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@interface MMSWebServiceInvocation : NSObject 
{
    NSString *authenticationString;
    id delegate;
    NSURL *endpointURL;
    NSMutableURLRequest *currentRequest;
    NSURLConnection *currentConnection;
    NSURLResponse *currentResponse;
    NSMutableData *receivedData;
    NSString *xmlMessage;
    NSString *httpMethod;

    BOOL didComplete;
    BOOL hasError;
}

+ (id)newWithURL:(NSURL *)anURL;

//
// Conveniences
//

- (NSString *)currentResponseDataAsString;

//
// Action Methods
//
- (void)prepareRequest;
- (void)performRequest;
//
// Accessors
//

- (NSString *)authenticationString;
- (void)setAuthenticationString:(NSString *)anAuthenticationString;

- (NSURLConnection *)currentConnection;
- (void)setCurrentConnection:(NSURLConnection *)aCurrentConnection;

- (NSMutableURLRequest *)currentRequest;
- (void)setCurrentRequest:(NSMutableURLRequest *)aCurrentRequest;

- (NSURLResponse *)currentResponse;
- (void)setCurrentResponse:(NSURLResponse *)aCurrentResponse;

- (id)delegate;
- (void)setDelegate:(id)aDelegate;

- (BOOL)didComplete;

- (NSURL *)endpointURL;
- (void)setEndpointURL:(NSURL *)anEndpointURL;

- (BOOL)hasError;

- (NSString *)httpMethod;
- (void)setHTTPMethod:(NSString *)anHTTPMethod;

- (NSString *)xmlMessage;
- (void)setXmlMessage:(NSString *)aXmlMessage;


@end
