//
//  NSDate_MMSCategories.h
//  MMSBase
//
//  Created by John Fox on 7/17/09.
//  Copyright 2009 GroupSmarts, LLC. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface NSDate (MMSCategories) 

+ (BOOL)isLeapYear:(NSInteger)aYear;

+ (NSInteger)numDaysInMonth:(NSInteger)aMonth
              forYear:(NSInteger)aYear;

- (NSInteger)monthIntervalFromDate:(NSDate *)aRefDate;

- (NSInteger)gregorianYear;
- (NSInteger)gregorianMonth;
- (NSString *)paddedGregorianMonthString;
- (NSInteger)gregorianDay;
- (NSString *)paddedGregorianDayString;

- (BOOL)isYearLessThanOrEqualToYearOfDate:(NSDate *)aDate;
- (BOOL)isMonthLessThanOrEqualToMonthOfDate:(NSDate *)aDate;
- (BOOL)isDayLessThanOrEqualToDayOfDate:(NSDate *)aDate;

- (NSDate *)dateExtendedToEndOfMonth;
- (NSDate *)dateExtendedToEndOfYear;
- (NSDate *)dateExtendedToBeginningOfFollowingYear;
- (NSDate *)dateExtendedToEndOfDay;
- (NSDate *)dateFromBeginningOfDay;
- (NSDate *)dateFromBeginningOfDecade;
- (NSDate *)dateFromBeginningOfYear;
- (NSDate *)dateFromBeginningOfMonth;

@end
