//
//  NSFileManager_Categories.h
//  MemoryMiner
//
//  Created by John Fox on 1/31/05.
//  Copyright 2005 WorldStream, Inc. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface NSFileManager (MMCategories)

+ (NSDictionary *)directoryAttributesDictionary;

- (BOOL)createRecursivePath:(NSString *)aPath;
- (BOOL)secureCreateDirectoryAtPath:(NSString *)path;

- (NSArray *)visibleDirectoryContentsAtPath:(NSString *)aPath;

- (unsigned long long)fileSizeAtPath:(NSString *)aPath;
- (NSDate *)creationDateForFileAtPath:(NSString *)aPath;
- (NSDate *)modificationDateForFileAtPath:(NSString *)aPath;

// Alias Support
- (NSString *)pathResolved:(NSString *)inPath;
- (BOOL)isAliasPath:(NSString *)inPath;
- (NSString *)resolveAliasPath:(NSString *)inPath;

@end
