//
//  NSString_Categories.h
//  MemoryMiner
//
//  Created by John Fox on 11/9/04.
//  Copyright 2004 MemoryMiner Software. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface NSString (MMSCategories)

+ (NSString *)formattedStringForBytes:(unsigned long long)bytes;

+ (NSString *)indentStringWithCount:(NSInteger)aCount;

+ (NSString *)dateTimeStamp;

+ (NSNumber *)numberFromGPSCoordinateString:(NSString *)inputString;

- (NSString *)encodedStringUsingDictionary:(NSDictionary *)encodingDictionary;
- (NSString *)encodedStringUsingDictionary:(NSDictionary *)encodingDictionary
                         swapValuesForKeys:(BOOL)swapValuesForKeys;

- (NSString *)stringByDeletingTrailingSlash;
- (NSString *)stringByRemovingAccents;
- (NSString *)stringWithEscapedQuotes;

- (NSString *)htmlParagraphText;

- (NSString *)urlEncodedString;

- (NSString *)xmlEncodedString;

- (NSString *)stringWithStrippedWhiteSpace;

- (NSString *)stringWithCharactersFromSet:(NSCharacterSet *)aSet;

- (NSString *)substringFromFirstOccurrenceOfString:(NSString *)firstString
                                     throughString:(NSString *)secondString;

- (NSString *)stringByRemovingControlCharacters;

- (NSString *)stringByTruncatingWhiteSpace;

- (NSString *)stringByTrimmingWhiteSpace;

- (NSString *)base64EncodedString;

- (BOOL)containsString:(NSString *)aString;

- (BOOL)isValidNumberUsingFormatString:(NSString *)formatString;

- (BOOL)isValidUnsignedInt;

- (BOOL)isValidInt;

- (BOOL)isEmpty;

// Date Component Validation
- (BOOL)isValidYearString;
- (BOOL)isValidMonthString;
- (BOOL)isValidDayString;
- (NSString *)paddedTwoDigitString;

// Filetype testing
- (BOOL)isJPEGFileType;
- (BOOL)isTIFFFileType;

// File path convenieneces
- (BOOL)isMountedFileSystemPath;
- (NSString *)mountedVolumeName;


@end

@interface NSString (NSString_SBJSON)

// JSON Encoding
- (id)JSONFragmentValue;
- (id)JSONValue;

@end

