//
//  MKGeocoder.j
//  StepInsideWeb
//
//  Created by John Fox on 9/28/09.
//  Copyright GroupSmarts, LLC 2009. All rights reserved.
//

@import <Foundation/CPObject.j>

@implementation MKGeocoder : CPObject
{
    CPString apiKey @accessors;
	id delegate @accessors;
	
	CPURLConnection geocodeConnection;
}

+ (id)newGeocoderWithAPIKey:(CPString)anAPIKey
				   delegate:(id)aDelegate
{
	var myGeocoder = [[self alloc] init];
    
	[myGeocoder setApiKey:anAPIKey];
	[myGeocoder setDelegate:aDelegate];
	
    return myGeocoder;
}

- (void)performGoogleGeocodeUsingSearchString:(CPString)aSearchString
{
	var myURLString = 'http://maps.google.com/maps/geo?q=' +escape(aSearchString) +'&output=json&oe=utf8&sensor=false&key=' +[self apiKey];
	
	log('will performGoogleGeocodeUsingSearchString myURLString is ' +myURLString);
	
	var request = [CPURLRequest requestWithURL:myURLString];
        
    //[request setHTTPMethod:"GET"];
    
	// Google Maps will only work with "callback" as the callback paremeter
	// Flickr expects jsoncallback
    geocodeConnection = [CPJSONPConnection connectionWithRequest:request callback:"callback" delegate:self];
}


- (void)connection:(CPJSONPConnection)aConnection didReceiveData:(CPString)data
{		
	if (delegate && ([delegate respondsToSelector:@selector(geocoder:didReceiveResponse:)]))
	{
		[delegate performSelector:@selector(geocoder:didReceiveResponse:)
					   withObject:self 
					   withObject:data];
	}
}

- (void)connection:(CPJSONPConnection)aConnection didFailWithError:(CPString)error
{
    alert(error);
}

@end